package net.rutles.magiccoin;

import java.util.List;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class MovingCoin extends SurfaceView
	implements 
	SurfaceHolder.Callback,
	SensorEventListener,
	Runnable {

	private Bitmap coin;
	private int surfaceWidth, surfaceHeight;
	private int px=10, py=10;
	private int coinWidth, coinHeight;
	private SurfaceHolder surfaceHolder;
	private Thread thread;
	private SensorManager sensorManager;
	private Sensor accelometer;
	private float gx=4, gy=4;
	private float vx=0, vy=0;
	private float elastic=(float) 0.75;

	
	public MovingCoin(Context context) {
		super(context);
		// TODO Auto-generated constructor stub
		
		sensorManager = (SensorManager) context.getSystemService(Context.SENSOR_SERVICE);
		List<Sensor> sensorList = sensorManager.getSensorList(Sensor.TYPE_ACCELEROMETER);
		if(sensorList.size() > 0) accelometer = sensorList.get(0);
		coin = BitmapFactory.decodeResource(
				getResources(),
				R.drawable.coin);
		coinWidth = coin.getWidth();
		coinHeight = coin.getHeight();

		surfaceHolder = getHolder();
		surfaceHolder.addCallback(this);
		setFocusable(true);
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		Canvas canvas;
		while(thread != null){
			canvas = surfaceHolder.lockCanvas();
			canvas.drawColor(Color.WHITE);
			canvas.drawBitmap(coin, px, py, null);
			surfaceHolder.unlockCanvasAndPost(canvas);
			
			vx += gx;
			if(px < 0 || surfaceWidth < px) vx = -(vx * elastic);
			px += vx;
			
			vy += gy;
			if(py < 0 || surfaceHeight < py) vy = -(vy * elastic);
			py += vy;
			
			try {
				Thread.sleep(50);
			}catch(Exception e){}
		}
	}

	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {
		// TODO Auto-generated method stub
		surfaceWidth = width - coinWidth;
		surfaceHeight = height - coinHeight;		
	}

	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		// TODO Auto-generated method stub
		if(accelometer != null){
			sensorManager.registerListener(
					this, 
					accelometer, 
					SensorManager.SENSOR_DELAY_NORMAL);
		}
		thread = new Thread(this);
		thread.start();
	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		// TODO Auto-generated method stub
		sensorManager.unregisterListener(this);
		thread = null;
	}

	@Override
	public void onAccuracyChanged(Sensor sensor, int accuracy) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onSensorChanged(SensorEvent event) {
		// TODO Auto-generated method stub
		if(event.sensor == accelometer){
			gx = event.values[0];
			gy = event.values[1];
		}
	}
}
